class MutKTSNUT2weapons extends Mutator
    config(user);

//This was taken from UTClassic.MutUseSniper
//This seems to be the best way to check replacment of ammo and weapons.
//This also makes sure that your weapon replaces the AssultRifle in weaponLockers

function bool CheckReplacement( Actor Other, out byte bSuperRelevant )
{
	local int i;
	local WeaponLocker L;

	bSuperRelevant = 0;
    if ( xWeaponBase(Other) != None ) //Check if a weaponBase exists
    {
		if ( xWeaponBase(Other).WeaponType == class'XWeapons.AssaultRifle' ) //Checks if the weapon type is set to AR
			xWeaponBase(Other).WeaponType = class'KTSNUT2weapons.KTSNUT2pistolA'; //Set the weapon Type to your weapon
		if ( xWeaponBase(Other).WeaponType == class'XWeapons.BioRifle' )
			xWeaponBase(Other).WeaponType = class'KTSNUT2weapons.KTSNUT2smg';
		if ( xWeaponBase(Other).WeaponType == class'XWeapons.LinkGun' )
			xWeaponBase(Other).WeaponType = class'KTSNUT2weapons.KTSNUT2rifle';
		if ( xWeaponBase(Other).WeaponType == class'XWeapons.ShockRifle' )
			xWeaponBase(Other).WeaponType = class'KTSNUT2weapons.KTSNUT2lr';
		if ( xWeaponBase(Other).WeaponType == class'XWeapons.Minigun' )
			xWeaponBase(Other).WeaponType = class'KTSNUT2weapons.KTSNUT2mgun';
		if ( xWeaponBase(Other).WeaponType == class'XWeapons.SniperRifle' )
			xWeaponBase(Other).WeaponType = class'KTSNUT2weapons.KTSNUT2sr';
		if ( xWeaponBase(Other).WeaponType == class'XWeapons.FlakCannon' )
			xWeaponBase(Other).WeaponType = class'KTSNUT2weapons.KTSNUT2lc';
		if ( xWeaponBase(Other).WeaponType == class'UTClassic.ClassicSniperRifle' )
			xWeaponBase(Other).WeaponType = class'KTSNUT2weapons.KTSNUT2sr';
		if ( xWeaponBase(Other).WeaponType == class'XWeapons.RocketLauncher' )
			xWeaponBase(Other).WeaponType = class'KTSNUT2weapons.KTSNUT2cgl';
		if ( xWeaponBase(Other).WeaponType == class'Onslaught.ONSGrenadeLauncher' )
			xWeaponBase(Other).WeaponType = class'KTSNUT2weapons.KTSNUT2smg';
	}
	else if ( AssaultRiflePickup(Other) != None ) //Checks If there's an ARPickup in the level
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2pistolA"); //Replace with Your weapon.
	else if ( AssaultAmmoPickup(Other) != None ) //Checks for AR ammo
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2pistolAAmmoPickup");// Replace with your weapon ammo
	else if ( BioRiflePickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2smg");
	else if ( BioAmmoPickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2pistolAAmmoPickup");
	else if ( LinkGunPickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2rifle");
	else if ( LinkAmmoPickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2rifleAmmoPickup");
	else if ( ShockRiflePickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2lr");
	else if ( ShockAmmoPickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2lrAmmoPickup");
	else if ( MinigunPickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2mgun");
	else if ( MinigunAmmoPickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2mgunAmmoPickup");
	else if ( SniperRiflePickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2sr");
	else if ( SniperAmmoPickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2srAmmoPickup");
	else if ( FlakCannonPickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2lc");
	else if ( FlakAmmoPickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2lrAmmoPickup");
	else if ( ClassicSniperRiflePickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2sr");
	else if ( ClassicSniperAmmoPickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2srAmmoPickup");
	else if ( RocketLauncherPickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2cgl");
	else if ( RocketAmmoPickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2cglAmmoPickup");
	else if ( ONSGrenadePickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2smg");
	else if ( ONSGrenadeAmmoPickup(Other) != None )
		ReplaceWith( Other, "KTSNUT2weapons.KTSNUT2pistolAAmmoPickup");
	else if ( WeaponLocker(Other) != None ) //Checks weaponlocker exists
	{
		L = WeaponLocker(Other); //Getting ready to loop through all of the weapon lockers...
		for (i = 0; i < L.Weapons.Length; i++) //Loops through ALL the weapon lockers on the map
			if (L.Weapons[i].WeaponClass == class'AssaultRifle') //Checks if the weaponlocker has an AR...
				L.Weapons[i].WeaponClass = class'KTSNUT2weapons.KTSNUT2pistolA'; // Replaces the weapon with your weapon.
			Else if (L.Weapons[i].WeaponClass == class'BioRifle')
				L.Weapons[i].WeaponClass = class'KTSNUT2weapons.KTSNUT2smg';
			Else if (L.Weapons[i].WeaponClass == class'LinkGun')
				L.Weapons[i].WeaponClass = class'KTSNUT2weapons.KTSNUT2rifle';
			Else if (L.Weapons[i].WeaponClass == class'ShockRifle')
				L.Weapons[i].WeaponClass = class'KTSNUT2weapons.KTSNUT2lr';
			Else if (L.Weapons[i].WeaponClass == class'Minigun')
				L.Weapons[i].WeaponClass = class'KTSNUT2weapons.KTSNUT2mgun';
			Else if (L.Weapons[i].WeaponClass == class'SniperRifle')
				L.Weapons[i].WeaponClass = class'KTSNUT2weapons.KTSNUT2sr';
			Else if (L.Weapons[i].WeaponClass == class'FlakCannon')
				L.Weapons[i].WeaponClass = class'KTSNUT2weapons.KTSNUT2lc';
			Else if (L.Weapons[i].WeaponClass == class'ClassicSniperRifle')
				L.Weapons[i].WeaponClass = class'KTSNUT2weapons.KTSNUT2sr';
			Else if (L.Weapons[i].WeaponClass == class'RocketLauncher')
				L.Weapons[i].WeaponClass = class'KTSNUT2weapons.KTSNUT2cgl';
			Else if (L.Weapons[i].WeaponClass == class'ONSGrenadeLauncher')
				L.Weapons[i].WeaponClass = class'KTSNUT2weapons.KTSNUT2smg';
		return true; // Return true. Game succesfully replaced weapons.
	}
	else
		return true; // Return True. Game succesfully replaced the weapons.
	return false; // Returns false. Only happens if all the If checks failed.
}

 function string GetInventoryClassOverride(string InventoryClassName)
{
    if (InventoryClassName == "XWeapons.AssaultRifle")
        InventoryClassName = "KTSNUT2weapons.KTSNUT2pistolA";
    return Super.GetInventoryClassOverride(InventoryClassName);
}

//=============================================================================

defaultproperties
{
     GroupName="KTSNweapons"
     FriendlyName="KTSNweapons"
     Description="Replaces AR, Bio, Link and etc. to G2984, M940, M960 and etc."
}